import User from "../models/User.js"
import isLength from 'validator/lib/isLength.js'
import isEmail from 'validator/lib/isEmail.js'
//꼭 js붙여주기!!
//isEmail

//sign validation해야됨
const signup = async (req, res) => {
    const { name, nickname, email, password } = req.body
    //req.body를 구조분해하여 각각 보이게함 -> 모든정보들이 한줄에 보임
    console.log(name, nickname, email, password)

    try {

        if (!isLength(name, { min: 3, max: 10 })) {
            //이범위를 벗어나면 error발생
            return res.status(422).send('Name must be 3-10 characters')
            //422 : 형식이 잘못되었다는 error발생
        } else if (!isLength(nickname, { min: 3, max: 10 })) {
            return res.status(422).send('Nickname must be 3-10 characters')
        } else if (!isEmail(email, {
            allow_display_name: true,
            require_display_name: true,
            allow_utf8_local_part: false,
        })) {
            return res.status(422).send('Email does not fit the format')
        } else if (!isLength(password, { min: 6, max: 25 })) {
            return res.status(422).send('Nickname must be 6-25 characters')
        }

        const newUser = await new User({
            name,
            nickname,
            email,
            password,
            //required를 하였기 때문에 이중 하나라도 없으면 에러 발생
        }).save()
        //save시 user schema형식에 맞는지 확인후 틀리면 error발생 맞으면 mongooDb로 들어감
        //save(promise)붙일 시 fuction 앞에 await 붙여주기 + async 함수 앞에 붙여주기
        console.log(newUser)
        res.json(newUser)

    } catch (error) {
        //알수없는 모든 에러발생시 처리
        console.log(error)
        res.status(500).send('User signup error')
    }

    //newUSer (객체)를 json형식으로 바꿔서 객체열로 보냄
    //res : 응답하는 객체
    //응답안할 시 browser에서 빙빙돌다 에러 발생 -> 꼭 붙여줘야됨!
    //res는 한번만 실행. 두번하면 에러 발생
}

const hello = (req, res) => {
    res.send('Hello from users controller')
}

export default { signup, hello }
// {} : 객체로 return함